// Code generated by goctl. DO NOT EDIT.
// Source: permission.proto

package permissionservice

import (
	"context"

	"ark-permission/gen_result/pb/permission"

	"github.com/zeromicro/go-zero/zrpc"
	"google.golang.org/grpc"
)

type (
	AuthorizationReq             = permission.AuthorizationReq
	CancelOneTimeTokenReq        = permission.CancelOneTimeTokenReq
	CancelTokenReq               = permission.CancelTokenReq
	CheckPermissionByRoleReq     = permission.CheckPermissionByRoleReq
	CreateOneTimeTokenReq        = permission.CreateOneTimeTokenReq
	CreateOneTimeTokenResp       = permission.CreateOneTimeTokenResp
	DoTokenByDeviceIDReq         = permission.DoTokenByDeviceIDReq
	DoTokenByUIDReq              = permission.DoTokenByUIDReq
	GetPermissionStatusByPathReq = permission.GetPermissionStatusByPathReq
	ListPermissionResp           = permission.ListPermissionResp
	ListPermissionStatusResp     = permission.ListPermissionStatusResp
	MapPermissionStatusResp      = permission.MapPermissionStatusResp
	NoneReq                      = permission.NoneReq
	OKResp                       = permission.OKResp
	PermissionItem               = permission.PermissionItem
	PermissionResp               = permission.PermissionResp
	PermissionStatusItem         = permission.PermissionStatusItem
	QueryTokenByUIDReq           = permission.QueryTokenByUIDReq
	RefreshTokenReq              = permission.RefreshTokenReq
	RefreshTokenResp             = permission.RefreshTokenResp
	Token                        = permission.Token
	TokenResp                    = permission.TokenResp
	Tokens                       = permission.Tokens
	ValidationTokenReq           = permission.ValidationTokenReq
	ValidationTokenResp          = permission.ValidationTokenResp

	PermissionService interface {
		// ListPermissionStatus 取得所有權限狀態列表,給前端表演用
		ListPermissionStatus(ctx context.Context, in *NoneReq, opts ...grpc.CallOption) (*ListPermissionStatusResp, error)
		// MapPermissionStatus 取得所有權限開閉狀態，簡易版，給前端表演用
		MapPermissionStatus(ctx context.Context, in *NoneReq, opts ...grpc.CallOption) (*MapPermissionStatusResp, error)
		// CheckPermissionByRole 透過角色 ID 來檢視權限，後台要通過時真的看這個
		CheckPermissionByRole(ctx context.Context, in *CheckPermissionByRoleReq, opts ...grpc.CallOption) (*PermissionResp, error)
		// GetPermissionStatusByPath 透過資源拿取角色的狀態
		GetPermissionStatusByPath(ctx context.Context, in *GetPermissionStatusByPathReq, opts ...grpc.CallOption) (*PermissionStatusItem, error)
	}

	defaultPermissionService struct {
		cli zrpc.Client
	}
)

func NewPermissionService(cli zrpc.Client) PermissionService {
	return &defaultPermissionService{
		cli: cli,
	}
}

// ListPermissionStatus 取得所有權限狀態列表,給前端表演用
func (m *defaultPermissionService) ListPermissionStatus(ctx context.Context, in *NoneReq, opts ...grpc.CallOption) (*ListPermissionStatusResp, error) {
	client := permission.NewPermissionServiceClient(m.cli.Conn())
	return client.ListPermissionStatus(ctx, in, opts...)
}

// MapPermissionStatus 取得所有權限開閉狀態，簡易版，給前端表演用
func (m *defaultPermissionService) MapPermissionStatus(ctx context.Context, in *NoneReq, opts ...grpc.CallOption) (*MapPermissionStatusResp, error) {
	client := permission.NewPermissionServiceClient(m.cli.Conn())
	return client.MapPermissionStatus(ctx, in, opts...)
}

// CheckPermissionByRole 透過角色 ID 來檢視權限，後台要通過時真的看這個
func (m *defaultPermissionService) CheckPermissionByRole(ctx context.Context, in *CheckPermissionByRoleReq, opts ...grpc.CallOption) (*PermissionResp, error) {
	client := permission.NewPermissionServiceClient(m.cli.Conn())
	return client.CheckPermissionByRole(ctx, in, opts...)
}

// GetPermissionStatusByPath 透過資源拿取角色的狀態
func (m *defaultPermissionService) GetPermissionStatusByPath(ctx context.Context, in *GetPermissionStatusByPathReq, opts ...grpc.CallOption) (*PermissionStatusItem, error) {
	client := permission.NewPermissionServiceClient(m.cli.Conn())
	return client.GetPermissionStatusByPath(ctx, in, opts...)
}
